<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DriverPrivateUsageReport StructType
 * @subpackage Structs
 */
class DriverPrivateUsageReport extends AbstractStructBase
{
    /**
     * The Username
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Username;
    /**
     * The PIN1
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $PIN1;
    /**
     * The PIN2
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $PIN2;
    /**
     * The StartDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $StartDate;
    /**
     * The EndDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $EndDate;
    /**
     * The Driver
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Driver;
    /**
     * The Compress
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Compress;
    /**
     * The Locale
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Locale;
    /**
     * The Language
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Language;
    /**
     * The DayByDay
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DayByDay;
    /**
     * The Detailed
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Detailed;
    /**
     * Constructor method for DriverPrivateUsageReport
     * @uses DriverPrivateUsageReport::setUsername()
     * @uses DriverPrivateUsageReport::setPIN1()
     * @uses DriverPrivateUsageReport::setPIN2()
     * @uses DriverPrivateUsageReport::setStartDate()
     * @uses DriverPrivateUsageReport::setEndDate()
     * @uses DriverPrivateUsageReport::setDriver()
     * @uses DriverPrivateUsageReport::setCompress()
     * @uses DriverPrivateUsageReport::setLocale()
     * @uses DriverPrivateUsageReport::setLanguage()
     * @uses DriverPrivateUsageReport::setDayByDay()
     * @uses DriverPrivateUsageReport::setDetailed()
     * @param string $username
     * @param string $pIN1
     * @param string $pIN2
     * @param string $startDate
     * @param string $endDate
     * @param string $driver
     * @param string $compress
     * @param string $locale
     * @param string $language
     * @param string $dayByDay
     * @param string $detailed
     */
    public function __construct($username = null, $pIN1 = null, $pIN2 = null, $startDate = null, $endDate = null, $driver = null, $compress = null, $locale = null, $language = null, $dayByDay = null, $detailed = null)
    {
        $this
            ->setUsername($username)
            ->setPIN1($pIN1)
            ->setPIN2($pIN2)
            ->setStartDate($startDate)
            ->setEndDate($endDate)
            ->setDriver($driver)
            ->setCompress($compress)
            ->setLocale($locale)
            ->setLanguage($language)
            ->setDayByDay($dayByDay)
            ->setDetailed($detailed);
    }
    /**
     * Get Username value
     * @return string|null
     */
    public function getUsername()
    {
        return $this->Username;
    }
    /**
     * Set Username value
     * @param string $username
     * @return \StructType\DriverPrivateUsageReport
     */
    public function setUsername($username = null)
    {
        // validation for constraint: string
        if (!is_null($username) && !is_string($username)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($username, true), gettype($username)), __LINE__);
        }
        $this->Username = $username;
        return $this;
    }
    /**
     * Get PIN1 value
     * @return string|null
     */
    public function getPIN1()
    {
        return $this->PIN1;
    }
    /**
     * Set PIN1 value
     * @param string $pIN1
     * @return \StructType\DriverPrivateUsageReport
     */
    public function setPIN1($pIN1 = null)
    {
        // validation for constraint: string
        if (!is_null($pIN1) && !is_string($pIN1)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($pIN1, true), gettype($pIN1)), __LINE__);
        }
        $this->PIN1 = $pIN1;
        return $this;
    }
    /**
     * Get PIN2 value
     * @return string|null
     */
    public function getPIN2()
    {
        return $this->PIN2;
    }
    /**
     * Set PIN2 value
     * @param string $pIN2
     * @return \StructType\DriverPrivateUsageReport
     */
    public function setPIN2($pIN2 = null)
    {
        // validation for constraint: string
        if (!is_null($pIN2) && !is_string($pIN2)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($pIN2, true), gettype($pIN2)), __LINE__);
        }
        $this->PIN2 = $pIN2;
        return $this;
    }
    /**
     * Get StartDate value
     * @return string|null
     */
    public function getStartDate()
    {
        return $this->StartDate;
    }
    /**
     * Set StartDate value
     * @param string $startDate
     * @return \StructType\DriverPrivateUsageReport
     */
    public function setStartDate($startDate = null)
    {
        // validation for constraint: string
        if (!is_null($startDate) && !is_string($startDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($startDate, true), gettype($startDate)), __LINE__);
        }
        $this->StartDate = $startDate;
        return $this;
    }
    /**
     * Get EndDate value
     * @return string|null
     */
    public function getEndDate()
    {
        return $this->EndDate;
    }
    /**
     * Set EndDate value
     * @param string $endDate
     * @return \StructType\DriverPrivateUsageReport
     */
    public function setEndDate($endDate = null)
    {
        // validation for constraint: string
        if (!is_null($endDate) && !is_string($endDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($endDate, true), gettype($endDate)), __LINE__);
        }
        $this->EndDate = $endDate;
        return $this;
    }
    /**
     * Get Driver value
     * @return string|null
     */
    public function getDriver()
    {
        return $this->Driver;
    }
    /**
     * Set Driver value
     * @param string $driver
     * @return \StructType\DriverPrivateUsageReport
     */
    public function setDriver($driver = null)
    {
        // validation for constraint: string
        if (!is_null($driver) && !is_string($driver)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($driver, true), gettype($driver)), __LINE__);
        }
        $this->Driver = $driver;
        return $this;
    }
    /**
     * Get Compress value
     * @return string|null
     */
    public function getCompress()
    {
        return $this->Compress;
    }
    /**
     * Set Compress value
     * @param string $compress
     * @return \StructType\DriverPrivateUsageReport
     */
    public function setCompress($compress = null)
    {
        // validation for constraint: string
        if (!is_null($compress) && !is_string($compress)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($compress, true), gettype($compress)), __LINE__);
        }
        $this->Compress = $compress;
        return $this;
    }
    /**
     * Get Locale value
     * @return string|null
     */
    public function getLocale()
    {
        return $this->Locale;
    }
    /**
     * Set Locale value
     * @param string $locale
     * @return \StructType\DriverPrivateUsageReport
     */
    public function setLocale($locale = null)
    {
        // validation for constraint: string
        if (!is_null($locale) && !is_string($locale)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($locale, true), gettype($locale)), __LINE__);
        }
        $this->Locale = $locale;
        return $this;
    }
    /**
     * Get Language value
     * @return string|null
     */
    public function getLanguage()
    {
        return $this->Language;
    }
    /**
     * Set Language value
     * @param string $language
     * @return \StructType\DriverPrivateUsageReport
     */
    public function setLanguage($language = null)
    {
        // validation for constraint: string
        if (!is_null($language) && !is_string($language)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($language, true), gettype($language)), __LINE__);
        }
        $this->Language = $language;
        return $this;
    }
    /**
     * Get DayByDay value
     * @return string|null
     */
    public function getDayByDay()
    {
        return $this->DayByDay;
    }
    /**
     * Set DayByDay value
     * @param string $dayByDay
     * @return \StructType\DriverPrivateUsageReport
     */
    public function setDayByDay($dayByDay = null)
    {
        // validation for constraint: string
        if (!is_null($dayByDay) && !is_string($dayByDay)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dayByDay, true), gettype($dayByDay)), __LINE__);
        }
        $this->DayByDay = $dayByDay;
        return $this;
    }
    /**
     * Get Detailed value
     * @return string|null
     */
    public function getDetailed()
    {
        return $this->Detailed;
    }
    /**
     * Set Detailed value
     * @param string $detailed
     * @return \StructType\DriverPrivateUsageReport
     */
    public function setDetailed($detailed = null)
    {
        // validation for constraint: string
        if (!is_null($detailed) && !is_string($detailed)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($detailed, true), gettype($detailed)), __LINE__);
        }
        $this->Detailed = $detailed;
        return $this;
    }
}
